module Database.PostgreSQL.Opium.Error (Error (..)) where

import Data.Text (Text)
import Database.PostgreSQL.LibPQ (ExecStatus, Row)

import Database.PostgreSQL.Opium.FromField (FieldError)

data Error
  = ErrorDecode Row Text FieldError
  | ErrorNoResult
  | ErrorInvalidResult ExecStatus Text
  | ErrorMissingColumn Text
  | ErrorUnexpectedNull Row Text
  deriving (Eq, Show)
